/[gentoo-x86]/sys-power/nut/nut-2.4.3-r1.ebuild
Gentoo

Contents of /sys-power/nut/nut-2.4.3-r1.ebuild

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.4 - (show annotations) (download)
Sat Feb 12 23:16:14 2011 UTC (8 years, 11 months ago) by ssuominen
Branch: MAIN
CVS Tags: HEAD
Changes since 1.3: +1 -1 lines
FILE REMOVED
old

(Portage version: 2.2.0_alpha23/cvs/Linux x86_64)

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/sys-power/nut/nut-2.4.3-r1.ebuild,v 1.3 2010/06/22 20:07:21 arfrever Exp $
4
5 EAPI="2"
6
7 inherit eutils fixheadtails autotools bash-completion
8
9 MY_P="${P/_/-}"
10
11 DESCRIPTION="Network-UPS Tools"
12 HOMEPAGE="http://www.networkupstools.org/"
13 # Nut mirrors are presently broken
14 SRC_URI="http://random.networkupstools.org/source/${PV%.*}/${MY_P}.tar.gz
15 http://www.networkupstools.org/source/${PV%.*}/${MY_P}.tar.gz"
16
17 S="${WORKDIR}/${MY_P}"
18
19 LICENSE="GPL-2"
20 SLOT="0"
21 KEYWORDS="~alpha ~amd64 ~ppc ~sparc ~x86 ~x86-fbsd"
22 IUSE="cgi snmp usb ssl hal xml"
23
24 RDEPEND="cgi? ( >=media-libs/gd-2[png] )
25 snmp? ( net-analyzer/net-snmp )
26 usb? ( =virtual/libusb-0* )
27 hal? ( >=sys-apps/hal-0.5.11 )
28 ssl? ( dev-libs/openssl )
29 xml? ( >=net-libs/neon-0.25.0 )
30 >=sys-fs/udev-114"
31 DEPEND="$RDEPEND
32 >=sys-apps/sed-4
33 >=sys-devel/autoconf-2.58
34 dev-util/pkgconfig"
35
36 # public files should be 644 root:root
37 NUT_PUBLIC_FILES="/etc/nut/{ups,upssched}.conf"
38 # private files should be 640 root:nut - readable by nut, writeable by root,
39 NUT_PRIVATE_FILES="/etc/nut/{upsd.conf,upsd.users,upsmon.conf}"
40 # public files should be 644 root:root, only installed if USE=cgi
41 NUT_CGI_FILES="/etc/nut/{{hosts,upsset}.conf,upsstats{,-single}.html}"
42
43 pkg_setup() {
44 enewgroup nut 84
45 enewuser nut 84 -1 /var/lib/nut nut,uucp
46 # As of udev-104, NUT must be in uucp and NOT in tty.
47 gpasswd -d nut tty 2>/dev/null
48 gpasswd -a nut uucp 2>/dev/null
49 use hal && gpasswd -a haldaemon nut 2>/dev/null
50 # in some cases on old systems it wasn't in the nut group either!
51 gpasswd -a nut nut 2>/dev/null
52 warningmsg ewarn
53 }
54
55 src_prepare() {
56 ht_fix_file configure.in
57
58 epatch "${FILESDIR}"/${PN}-2.4.1-no-libdummy.patch
59 epatch "${FILESDIR}"/${PN}-2.4.3-lowspeed-buffer-size.patch
60
61 sed -e "s:GD_LIBS.*=.*-L/usr/X11R6/lib \(.*\) -lXpm -lX11:GD_LIBS=\"\1:" \
62 -i configure.in || die "sed failed"
63
64 sed -e "s:52.nut-usbups.rules:70-nut-usbups.rules:" \
65 -i scripts/udev/Makefile.am || die "sed failed"
66
67 rm -f ltmain.sh m4/lt* m4/libtool.m4
68
69 WANT_AUTOCONF=2.5 eautoreconf || die "autoconf failed"
70 }
71
72 src_configure() {
73 local myconf
74
75 if [ -n "${NUT_DRIVERS}" ]; then
76 myconf="${myconf} --with-drivers=${NUT_DRIVERS// /,}"
77 fi
78
79 econf \
80 --with-user=nut \
81 --with-group=nut \
82 --with-drvpath=/lib/nut \
83 --sysconfdir=/etc/nut \
84 --with-logfacility=LOG_DAEMON \
85 --with-statepath=/var/lib/nut \
86 --with-htmlpath=/usr/share/nut/html \
87 --datarootdir=/usr/share/nut \
88 --datadir=/usr/share/nut \
89 --with-dev \
90 $(use_with xml neon) \
91 $(use_with hal) \
92 $(use_with ssl) \
93 $(use_with usb) \
94 $(use_with snmp) \
95 $(use_with cgi) \
96 $(use_with cgi cgipath /usr/share/nut/cgi) \
97 ${myconf} || die "econf failed"
98
99 }
100
101 src_install() {
102
103 emake DESTDIR="${D}" install || die "make install failed"
104
105 dodir /sbin
106 dosym /lib/nut/upsdrvctl /sbin/upsdrvctl
107 # This needs to exist for the scripts
108 dosym /lib/nut/upsdrvctl /usr/sbin/upsdrvctl
109
110 if use cgi; then
111 elog "CGI monitoring scripts are installed in /usr/share/nut/cgi."
112 elog "copy them to your web server's ScriptPath to activate (this is a"
113 elog "change from the old location)."
114 elog "If you use lighttpd, see lighttpd_nut.conf in the documentation."
115 fi
116
117 # this must be done after all of the install phases
118 for i in "${D}"/etc/nut/*.sample ; do
119 mv "${i}" "${i/.sample/}"
120 done
121
122 dodoc ChangeLog INSTALL MAINTAINERS NEWS README UPGRADING \
123 docs/{FAQ,*.txt} || die
124
125 newdoc lib/README README.lib || die
126
127 newdoc "${FILESDIR}"/lighttpd_nut.conf-2.2.0 lighttpd_nut.conf || die
128
129 docinto cables
130 dodoc docs/cables/* || die
131
132 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsd upsd \
133 || die "newinitd failed"
134 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsdrv upsdrv \
135 || die "newinitd failed"
136 newinitd "${FILESDIR}"/nut-2.2.2-init.d-upsmon upsmon \
137 || die "newinitd failed"
138 newinitd "${FILESDIR}"/nut.powerfail.initd nut.powerfail \
139 || die "newinitd failed"
140
141 # This sets up permissions for nut to access a UPS
142 insinto /etc/udev/rules.d/
143 newins scripts/udev/nut-usbups.rules 70-nut-usbups.rules
144
145 keepdir /var/lib/nut
146
147 einfo "Setting up permissions on files and directories"
148 fperms 0700 /var/lib/nut
149 fowners nut:nut /var/lib/nut
150
151 # Do not remove eval here, because the variables contain shell expansions.
152 eval fperms 0640 ${NUT_PRIVATE_FILES}
153 eval fowners root:nut ${NUT_PRIVATE_FILES}
154
155 # Do not remove eval here, because the variables contain shell expansions.
156 eval fperms 0644 ${NUT_PUBLIC_FILES}
157 eval fowners root:root ${NUT_PUBLIC_FILES}
158
159 # Do not remove eval here, because the variables contain shell expansions.
160 if use cgi; then
161 eval fperms 0644 ${NUT_CGI_FILES}
162 eval fowners root:root ${NUT_CGI_FILES}
163 fi
164
165 # this is installed for 2.4 and fbsd guys
166 if ! has_version sys-fs/udev; then
167 einfo "Installing non-udev hotplug support"
168 insinto /etc/hotplug/usb
169 insopts -m 755
170 doins scripts/hotplug/nut-usbups.hotplug
171 fi
172
173 if use hal; then
174 einfo "Installing HAL support"
175 insinto /usr/share/hal/fdi/information/20thirdparty/
176 doins scripts/hal/20-ups-nut-device.fdi
177 insinto /usr/libexec
178 insopts -m 755
179 doins drivers/hald-addon-*
180 rm "${D}"/lib/nut/hald-addon-*
181 fi
182
183 dobashcompletion "${S}"/scripts/misc/nut.bash_completion
184 }
185
186 pkg_postinst() {
187 # this is to ensure that everybody that installed old versions still has
188 # correct permissions
189
190 chown nut:nut "${ROOT}"/var/lib/nut 2>/dev/null
191 chmod 0700 "${ROOT}"/var/lib/nut 2>/dev/null
192
193 # Do not remove eval here, because the variables contain shell expansions.
194 eval chown root:nut "${ROOT}"${NUT_PRIVATE_FILES} 2>/dev/null
195 eval chmod 0640 "${ROOT}"${NUT_PRIVATE_FILES} 2>/dev/null
196
197 # Do not remove eval here, because the variables contain shell expansions.
198 eval chown root:root "${ROOT}"${NUT_PUBLIC_FILES} 2>/dev/null
199 eval chmod 0644 "${ROOT}"${NUT_PUBLIC_FILES} 2>/dev/null
200
201 # Do not remove eval here, because the variables contain shell expansions.
202 if use cgi; then
203 eval chown root:root "${ROOT}"${NUT_CGI_FILES} 2>/dev/null
204 eval chmod 0644 "${ROOT}"${NUT_CGI_FILES} 2>/dev/null
205 fi
206
207 warningmsg elog
208 }
209
210 warningmsg() {
211 msgfunc="$1"
212 [ -z "$msgfunc" ] && die "msgfunc not specified in call to warningmsg!"
213 ${msgfunc} "Please note that NUT now runs under the 'nut' user."
214 ${msgfunc} "NUT is in the uucp group for access to RS-232 UPS."
215 ${msgfunc} "However if you use a USB UPS you may need to look at the udev or"
216 ${msgfunc} "hotplug rules that are installed, and alter them suitably."
217 ${msgfunc} ''
218 ${msgfunc} "If you use hald, you may be able to skip the normal init scripts."
219 ${msgfunc} ''
220 ${msgfunc} "You are strongly advised to read the UPGRADING file provided by upstream."
221 ${msgfunc} ''
222 ${msgfunc} "Please note that upsdrv is NOT automatically started by upsd anymore."
223 ${msgfunc} "If you have multiple UPS units, you can use their NUT names to"
224 ${msgfunc} "have a service per UPS:"
225 ${msgfunc} "ln -s /etc/init.d/upsdrv /etc/init.d/upsdrv.\$UPSNAME"
226 ${msgfunc} ''
227 ${msgfunc} 'If you want apcupsd to power off your UPS when it'
228 ${msgfunc} 'shuts down your system in a power failure, you must'
229 ${msgfunc} 'add nut.powerfail to your shutdown runlevel:'
230 ${msgfunc} ''
231 ${msgfunc} 'rc-update add nut.powerfail shutdown'
232 ${msgfunc} ''
233
234 }

  ViewVC Help
Powered by ViewVC 1.1.20